import partial from 'lodash.partial';
import { shouldReturn } from './should-return';
export var not = function not(context) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be negated if the test was executed.");
  }

  if (environment.isAssertionNegated()) {
    throw Error("Assertion already negated.");
  }

  environment.negateAssertion();
  return Object.assign(environment.promise, {
    shouldReturn: partial(shouldReturn, context)
  });
};
//# sourceMappingURL=not.js.map