import partial from 'lodash.partial';
import { as } from './as';
import { not } from './not';
import { shouldReturn } from './should-return';
export var withSecretsManager = function withSecretsManager(context, manager) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Secrets manager cannot be assigned if the test was executed.");
  }

  environment.setSecretsManager(manager);
  return Object.assign(environment.promise, {
    as: partial(as, context),
    shouldReturn: partial(shouldReturn, context),
    not: partial(not, context)
  });
}; // FIXME: deprecated

export var setSecretsManager = function setSecretsManager(context, manager) {
  // eslint-disable-next-line no-console
  console.warn("'setSecretsManager' deprecated, you should use withSecretsManager instead");
  return withSecretsManager(context, manager);
};
//# sourceMappingURL=with-secrets-manager.js.map