import partial from 'lodash.partial';
import { withAdapter } from './with-adapter';
import { withEncryption } from './with-encryption';
import { withSecretsManager } from './with-secrets-manager';
import { startSideEffectsFrom } from './start-side-effects-from';
import { makeAssertions } from './make-assertions';
export var allowSideEffects = function allowSideEffects(context) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Side effects cannot be allowed if the test was executed.");
  }

  environment.allowSideEffects();
  return Object.assign(makeAssertions(context), {
    withAdapter: partial(withAdapter, context),
    withEncryption: partial(withEncryption, context),
    withSecretsManager: partial(withSecretsManager, context),
    startSideEffectsFrom: partial(startSideEffectsFrom, context)
  });
};
//# sourceMappingURL=allow-side-effects.js.map