import partial from 'lodash.partial';
import { withAdapter } from './with-adapter';
import { withEncryption } from './with-encryption';
import { allowSideEffects } from './allow-side-effects';
import { startSideEffectsFrom } from './start-side-effects-from';
import { makeAssertions } from './make-assertions';
export var withSecretsManager = function withSecretsManager(context, manager) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Secrets manager cannot be assigned if the test was executed.");
  }

  environment.setSecretsManager(manager);
  return Object.assign(makeAssertions(context), {
    withAdapter: partial(withAdapter, context),
    withEncryption: partial(withEncryption, context),
    allowSideEffects: partial(allowSideEffects, context),
    startSideEffectsFrom: partial(startSideEffectsFrom, context)
  });
};
//# sourceMappingURL=with-secrets-manager.js.map