"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withAdapter = void 0;

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _withEncryption = require("./with-encryption");

var _withSecretsManager = require("./with-secrets-manager");

var _allowSideEffects = require("./allow-side-effects");

var _startSideEffectsFrom = require("./start-side-effects-from");

var _makeAssertions = require("./make-assertions");

var withAdapter = function withAdapter(context, adapter) {
  if (context.environment.isExecuted()) {
    throw Error("Adapter cannot be assigned if the test was executed.");
  }

  if (context.adapter != null) {
    throw Error("Saga storage adapter already assigned.");
  }

  context.adapter = adapter;
  return Object.assign((0, _makeAssertions.makeAssertions)(context), {
    withEncryption: (0, _lodash["default"])(_withEncryption.withEncryption, context),
    withSecretsManager: (0, _lodash["default"])(_withSecretsManager.withSecretsManager, context),
    allowSideEffects: (0, _lodash["default"])(_allowSideEffects.allowSideEffects, context),
    startSideEffectsFrom: (0, _lodash["default"])(_startSideEffectsFrom.startSideEffectsFrom, context)
  });
};

exports.withAdapter = withAdapter;
//# sourceMappingURL=with-adapter.js.map