"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getEventStore = exports.validateEvents = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _eventstoreLite = _interopRequireDefault(require("@resolve-js/eventstore-lite"));

var _prepareEvents = require("./prepare-events");

var _constants = require("../constants");

var _excluded = ["events"];

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var validateEvents = function validateEvents(events) {
  var stampedCount = events.filter(function (event) {
    return event.timestamp != null;
  }).length;

  if (stampedCount !== events.length && stampedCount > 0) {
    throw Error(_constants.ambiguousEventsTimeErrorMessage);
  }
};

exports.validateEvents = validateEvents;

var getEventStore = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(events, context) {
    var preparedEvents, eventByAggregateIdVersion, eventIndex, _preparedEvents$event, aggregateId, aggregateVersion, event, eventStoreAdapter, _iterator, _step, _event;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            validateEvents(events);
            preparedEvents = (0, _prepareEvents.prepareEvents)(events, context);
            eventByAggregateIdVersion = new Map();

            for (eventIndex = 0; eventIndex < events.length; eventIndex++) {
              _preparedEvents$event = preparedEvents[eventIndex], aggregateId = _preparedEvents$event.aggregateId, aggregateVersion = _preparedEvents$event.aggregateVersion;
              event = events[eventIndex];

              if (event != null) {
                eventByAggregateIdVersion.set(aggregateId + ":" + aggregateVersion, event);
              }
            }

            eventStoreAdapter = (0, _eventstoreLite["default"])({
              databaseFile: ':memory:'
            });
            _context2.next = 7;
            return eventStoreAdapter.init();

          case 7:
            _iterator = _createForOfIteratorHelperLoose(preparedEvents);

          case 8:
            if ((_step = _iterator()).done) {
              _context2.next = 14;
              break;
            }

            _event = _step.value;
            _context2.next = 12;
            return eventStoreAdapter.saveEvent(_event);

          case 12:
            _context2.next = 8;
            break;

          case 14:
            return _context2.abrupt("return", (0, _extends2["default"])({}, eventStoreAdapter, {
              loadEvents: function () {
                var _loadEvents = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
                  var _yield$eventStoreAdap,
                      originalEvents,
                      other,
                      eventsFromEventStore,
                      timestampIndex,
                      _eventByAggregateIdVe,
                      _eventByAggregateIdVe2,
                      eventFromEventStore,
                      _args = arguments;

                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return eventStoreAdapter.loadEvents.apply(eventStoreAdapter, _args);

                        case 2:
                          _yield$eventStoreAdap = _context.sent;
                          originalEvents = _yield$eventStoreAdap.events;
                          other = (0, _objectWithoutPropertiesLoose2["default"])(_yield$eventStoreAdap, _excluded);
                          eventsFromEventStore = JSON.parse(JSON.stringify(originalEvents));

                          for (timestampIndex = 0; timestampIndex < eventsFromEventStore.length; timestampIndex++) {
                            eventFromEventStore = eventsFromEventStore[timestampIndex];
                            eventFromEventStore.timestamp = (_eventByAggregateIdVe = (_eventByAggregateIdVe2 = eventByAggregateIdVersion.get(eventFromEventStore.aggregateId + ":" + eventFromEventStore.aggregateVersion)) == null ? void 0 : _eventByAggregateIdVe2.timestamp) != null ? _eventByAggregateIdVe : timestampIndex;
                          }

                          return _context.abrupt("return", (0, _extends2["default"])({}, other, {
                            events: eventsFromEventStore
                          }));

                        case 8:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                function loadEvents() {
                  return _loadEvents.apply(this, arguments);
                }

                return loadEvents;
              }()
            }));

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getEventStore(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.getEventStore = getEventStore;
//# sourceMappingURL=get-event-store.js.map