"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.getSagaRuntime = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _utils = require("./utils");

var executeCommand = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(buffer, schedulerName, mockedImplementations, command) {
    var payload, implementation;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(command.aggregateName === schedulerName)) {
              _context.next = 5;
              break;
            }

            payload = command.payload;
            buffer.scheduledCommands.push({
              date: payload.date,
              command: payload.command
            });
            _context.next = 10;
            break;

          case 5:
            buffer.commands.push(command);
            implementation = mockedImplementations.get((0, _utils.getCommandImplementationKey)(command));

            if (!(typeof implementation === 'function')) {
              _context.next = 10;
              break;
            }

            _context.next = 10;
            return implementation(command);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function executeCommand(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var executeQuery = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(buffer, mockedImplementations, query) {
    var implementation;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            buffer.queries.push(query);
            implementation = mockedImplementations.get((0, _utils.getQueryImplementationKey)(query));

            if (!(typeof implementation === 'function')) {
              _context2.next = 5;
              break;
            }

            _context2.next = 5;
            return implementation(query);

          case 5:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function executeQuery(_x5, _x6, _x7) {
    return _ref2.apply(this, arguments);
  };
}();

var makeScheduler = function makeScheduler() {
  return {
    addEntries: function addEntries() {
      return void 0;
    },
    clearEntries: function clearEntries() {
      return void 0;
    },
    executeEntries: function executeEntries() {
      return void 0;
    }
  };
};

var getSagaRuntime = function getSagaRuntime(buffer, mockedImplementations, schedulerName, secretsManager, monitoring, sideEffectsStartTimestamp, uploader) {
  if (uploader === void 0) {
    uploader = null;
  }

  var sideEffectsTimestamp = sideEffectsStartTimestamp;
  return {
    secretsManager: secretsManager,
    monitoring: monitoring,
    executeCommand: (0, _lodash["default"])(executeCommand, buffer, schedulerName, mockedImplementations.commands),
    executeQuery: (0, _lodash["default"])(executeQuery, buffer, mockedImplementations.queries),
    scheduler: makeScheduler(),
    uploader: uploader,
    getSideEffectsTimestamp: function () {
      var _getSideEffectsTimestamp = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt("return", sideEffectsTimestamp);

              case 1:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function getSideEffectsTimestamp() {
        return _getSideEffectsTimestamp.apply(this, arguments);
      }

      return getSideEffectsTimestamp;
    }(),
    setSideEffectsTimestamp: function () {
      var _setSideEffectsTimestamp = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(value) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                sideEffectsTimestamp = value;

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function setSideEffectsTimestamp(_x8) {
        return _setSideEffectsTimestamp.apply(this, arguments);
      }

      return setSideEffectsTimestamp;
    }()
  };
};

exports.getSagaRuntime = getSagaRuntime;
//# sourceMappingURL=get-saga-runtime.js.map