"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.prepareEvents = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var prepareEvents = function prepareEvents(events, context) {
  var timestamp = Date.now() + 60 * 1000;
  var aggregateVersionsMap = new Map();
  return events.map(function (testEvent) {
    var aggregateId = testEvent.aggregateId != null ? testEvent.aggregateId : context == null ? void 0 : context.aggregateId;
    var aggregateVersion = aggregateVersionsMap.has(aggregateId) ? aggregateVersionsMap.get(aggregateId) + 1 : 1;
    var event = (0, _extends2["default"])({}, testEvent, {
      aggregateId: aggregateId,
      aggregateVersion: aggregateVersion,
      timestamp: timestamp++
    });
    aggregateVersionsMap.set(aggregateId, aggregateVersion);
    return event;
  });
};

exports.prepareEvents = prepareEvents;
//# sourceMappingURL=prepare-events.js.map