import { TestSaga, GivenEventsContext, OmitFirstArgument } from '../../types';
import { SagaAssertionsNode } from './make-assertions';
import { withAdapter } from './with-adapter';
import { withEncryption } from './with-encryption';
import { withSecretsManager } from './with-secrets-manager';
import { allowSideEffects } from './allow-side-effects';
import { startSideEffectsFrom } from './start-side-effects-from';
export declare type SagaNode = {
    withAdapter: OmitFirstArgument<typeof withAdapter>;
    withEncryption: OmitFirstArgument<typeof withEncryption>;
    withSecretsManager: OmitFirstArgument<typeof withSecretsManager>;
    allowSideEffects: OmitFirstArgument<typeof allowSideEffects>;
    startSideEffectsFrom: OmitFirstArgument<typeof startSideEffectsFrom>;
} & SagaAssertionsNode;
export declare const saga: (givenEventsContext: GivenEventsContext, saga: TestSaga) => SagaNode;
